% New article: mdpi-Processes
% Special Issue: 
% DATAKtrain, DATAKtest and Model Construction v2
% STATE is a cell array with 200 x 1 cells

% The work spaces are protected. If you want to activate the 
% saving instructions, erase the character %.
% Other tests are carryed out as well.

load('WS_data200','UstarRHC','STATE','JMAT');
SOCSK=zeros(200,3); % SOCSK (States and Optimal Controls for the Same K)
                    % is a matrix including states and the optimal control
                    % output for the same k, 0<=k<=119; 
                    % columns: 2 states + 1 optimal output(the 3rd column)
COEFF=zeros(120,2);
MODEL=cell(120,1);
DATAKTest=cell(120,1);
DATAKTrain=cell(120,1);
% Treat particularly the case k=0 
kplus1=1; %mutual position in the tables of STATE (from 1 to 120)
fprintf('&&&&&&&  k+1 = %2d \n', kplus1);
 
for i=1:200
  % Select the states from line k of the state matrix and the output
  % from column k of the matrix UstarRHC.
  SOCSK(i,:)=[STATE{i,1}(kplus1,1:2) UstarRHC(i,kplus1)];
end
disp(SOCSK(1:10,:));
disp('***************************************\n');

% Create a table from matrix SOCSK
% datak: Cell array for the matrices devoted to the states reached at
% mutual sampling time over all optimal processes.
datak0=array2table(SOCSK,'VariableNames',{'x1','x2','u'});
disp('datak0');
disp(datak0(1:10,:));
disp('***************************************');
datak0p=removevars(datak0,'x2');
datakTest0=datak0p(1:60,:);
datakTrain0=datak0p(61:200,:);
%Train the mdl1
mdl1 = fitlm(datakTrain0);
disp(mdl1);
uPred = predict(mdl1,datakTest0);
x10=0.345;
%x20=0.;
u1=feval(mdl1,x10);
str=sprintf('Prediction: x10=%7.4f u1=%7.4f',x10,u1);
disp(str);
% **************
coef=mdl1.Coefficients.Estimate;
disp(coef);
COEFF(kplus1,1)=coef(1);
COEFF(kplus1,2)=coef(2);
u1p=COEFF(kplus1,1)+x10*COEFF(kplus1,2); %+x20*COEFF(kplus1,3);
disp(u1p);
CompTable=addvars(datakTest0,uPred);
disp(CompTable);
disp('***************************************');


